<?php
if ( ! function_exists( 'mobile_app_launch_setup' ) ) :
function mobile_app_launch_setup() {

// Root path/URI.
define( 'MOBILE_APP_LAUNCH_PARENT_DIR', get_template_directory() );
define( 'MOBILE_APP_LAUNCH_PARENT_URI', get_template_directory_uri() );

// Root path/URI.
define( 'MOBILE_APP_LAUNCH_PARENT_INC_DIR', MOBILE_APP_LAUNCH_PARENT_DIR . '/inc');
define( 'MOBILE_APP_LAUNCH_PARENT_INC_URI', MOBILE_APP_LAUNCH_PARENT_URI . '/inc');

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'wc-product-gallery-zoom' );
	add_theme_support( 'wc-product-gallery-slider' );

	/*
	 * Let WordPress manage the document title.
	 */
	add_theme_support( 'title-tag' );

	add_theme_support( 'responsive-embeds' );
	
	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 */
	add_theme_support( 'post-thumbnails' );
	
	//Add selective refresh for sidebar widget
	add_theme_support( 'customize-selective-refresh-widgets' );
	
	/*
	 * Make theme available for translation.
	 */
	load_theme_textdomain( 'mobile-app-launch', get_stylesheet_directory() . '/languages' );
		
	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary'  => esc_html__( 'Primary Menu', 'mobile-app-launch' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );
		
	add_theme_support('custom-logo');

	/*
	 * WooCommerce Plugin Support
	 */
	add_theme_support( 'woocommerce' );
	
	// Gutenberg wide images.
	add_theme_support( 'align-wide' );
	
	
	//Set up the WordPress core custom background feature.
	add_theme_support( 'custom-background', apply_filters( 'mobile_app_launch_custom_background_args', array(
		'default-color' => 'ffffff',
		'default-image' => '',
	) ) );

	
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, icons, and column width.
	 */
	add_editor_style( array( 'assets/css/editor-style.css', mobile_app_launch_google_font_url() ) );

	add_theme_support( 'custom-header', apply_filters( 'mobile_app_launch_custom_header_args', array(
		'default-image'          => get_template_directory_uri() . '/assets/images/custom-header.png',
		'default-text-color'     => 'ffffff',
		'width'                  => 2000, 
		'height'                 => 200,
		'flex-width'    		 => true,
		'flex-height'    		 => true,
        'uploads'            => true,
	)));


    /*
    * Enable support for Post Formats.
    *
    * See: https://codex.wordpress.org/Post_Formats
    */
    add_theme_support( 'post-formats', array('image','video','gallery','audio',) );


    //  --------------------------------------------- ENQUEUE ----------------------------------------------------- //

    /**
     * Implement the Custom Header feature.
     */
    require_once get_template_directory() . '/inc/custom-header.php';

    /**
     * Demo Import
     */
    require get_parent_theme_file_path( '/demo-import/demo-import-settings.php' );

    if ( ! defined( 'MOBILE_APP_LAUNCH_FREE_THEME_URL' ) ) {
	define( 'MOBILE_APP_LAUNCH_FREE_THEME_URL', 'https://www.seothemesexpert.com/products/free-mobile-app-wordpress-theme' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_PRO_THEME_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_PRO_THEME_URL', 'https://www.seothemesexpert.com/products/mobile-app-website-template' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_FREE_DOCS_THEME_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_FREE_DOCS_THEME_URL', 'https://demo.seothemesexpert.com/documentation/mobile-app-launch/' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_DEMO_THEME_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_DEMO_THEME_URL', 'https://demo.seothemesexpert.com/mobile-app-launch/' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_RATE_THEME_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_RATE_THEME_URL', 'https://wordpress.org/support/theme/mobile-app-launch/reviews/#new-post' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_SUPPORT_THEME_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_SUPPORT_THEME_URL', 'https://wordpress.org/support/theme/mobile-app-launch/' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_THEME_BUNDLE_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_THEME_BUNDLE_URL', 'https://www.seothemesexpert.com/products/wordpress-theme-bundle' );
    }
    if ( ! defined( 'MOBILE_APP_LAUNCH_DEMO_IMPORT_URL' ) ) {
        define( 'MOBILE_APP_LAUNCH_DEMO_IMPORT_URL', esc_url( admin_url( 'themes.php?page=mobileapplaunch-wizard' ) ) );
    }
}
endif;
add_action( 'after_setup_theme', 'mobile_app_launch_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function mobile_app_launch_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'mobile_app_launch_content_width', 1170 );
}
add_action( 'after_setup_theme', 'mobile_app_launch_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */

function mobile_app_launch_widgets_init() {
	
	register_sidebar( array(
		'name' => __( 'Sidebar Widget Area', 'mobile-app-launch' ),
		'id' => 'mobile-app-launch-sidebar-primary',
		'description' => __( 'The Primary Widget Area', 'mobile-app-launch' ),
		'before_widget' => '<aside id="%1$s" class="widget %2$s wow fadeInUp">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4><div class="title"><span class="shap"></span></div>',
	) );
	
	register_sidebar( array(
		'name' => __( 'Footer Widget Area', 'mobile-app-launch' ),
		'id' => 'mobile-app-launch-footer-widget-area',
		'description' => __( 'The Footer Widget Area', 'mobile-app-launch' ),
		'before_widget' => '<div class="footer-widget col-lg-3 col-sm-6 wow fadeIn" data-wow-delay="0.5s"><aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside></div>',
		'before_title' => '<h5 class="widget-title w-title">',
		'after_title' => '</h5><span class="shap"></span>',
	) );
}
add_action( 'widgets_init', 'mobile_app_launch_widgets_init' );

/**
 * All Styles & Scripts.
 */

require_once get_template_directory() . '/inc/enqueue.php';

/**
 * Nav Walker fo Bootstrap Dropdown Menu.
 */

require_once get_template_directory() . '/inc/class-wp-bootstrap-navwalker.php';

/**
 * Custom template tags for this theme.
 */
require_once get_template_directory() . '/inc/template-tags.php';

/**
 * Custom functions that act independently of the theme templates.
 */
require_once get_template_directory() . '/inc/extras.php';

/**
 * Customizer additions.
 */
require_once get_template_directory() . '/inc/customizer.php';

require_once get_template_directory() . '/inc/fonts.php';

require_once get_template_directory() . '/wptt-webfont-loader.php';


add_filter( 'nav_menu_link_attributes', 'mobile_app_launch_dropdown_data_attribute', 20, 3 );
/**
 * Use namespaced data attribute for Bootstrap's dropdown toggles.
 *
 * @param array    $atts HTML attributes applied to the item's `<a>` element.
 * @param WP_Post  $item The current menu item.
 * @param stdClass $args An object of wp_nav_menu() arguments.
 * @return array
 */
function mobile_app_launch_dropdown_data_attribute( $atts, $item, $args ) {
    if ( is_a( $args->walker, 'WP_Bootstrap_Navwalker' ) ) {
        if ( array_key_exists( 'data-toggle', $atts ) ) {
            unset( $atts['data-toggle'] );
            $atts['data-bs-toggle'] = 'dropdown';
        }
    }
    return $atts;
}

function mobile_app_launch_remove_theme_customizer_setting($wp_customize) {
    // Remove the setting
    $wp_customize->remove_setting('display_header_text');
    // Remove the control
    $wp_customize->remove_control('display_header_text');
}
add_action('customize_register', 'mobile_app_launch_remove_theme_customizer_setting', 20); 
// Use a priority greater than the one used for adding the setting


// Set the number of products per row to 3 on the shop page
add_filter('loop_shop_columns', 'mobile_app_launch_custom_shop_loop_columns');

if (!function_exists('mobile_app_launch_custom_shop_loop_columns')) {
    function mobile_app_launch_custom_shop_loop_columns() {
        // Retrieve the number of columns from theme customizer setting (default: 3)
        $mobile_app_launch_columns = get_theme_mod('mobile_app_launch_custom_shop_per_columns', 3);
        return $mobile_app_launch_columns;
    }
}

function mobile_app_launch_custom_controls() {
	
	load_template( trailingslashit( get_template_directory() ) . '/inc/customizer/customizer-custom-controls.php' );
}
add_action( 'customize_register', 'mobile_app_launch_custom_controls' );

// Set the number of products per page on the shop page
add_filter('loop_shop_per_page', 'mobile_app_launch_custom_shop_per_page', 20);

if (!function_exists('mobile_app_launch_custom_shop_per_page')) {
    function mobile_app_launch_custom_shop_per_page($mobile_app_launch_products_per_page) {
        // Retrieve the number of products per page from theme customizer setting (default: 9)
        $mobile_app_launch_products_per_page = get_theme_mod('mobile_app_launch_custom_shop_product_per_page', 9);
        return $mobile_app_launch_products_per_page;
    }
}

/**
 * Generate Google Fonts URL.
 */
function mobile_app_launch_google_font_url() {
    // Corrected Google Fonts URL format
    $google_fonts_url = 'https://fonts.googleapis.com/css2?family=Inter:opsz,wght@0,14..32,100..900;1,14..32,100..900&display=swap';
    return $google_fonts_url; 
}


function mobile_app_launch_scripts_styles() {
	$mobile_app_launch_headings_font = esc_html(get_theme_mod('mobile_app_launch_headings_text'));
	$mobile_app_launch_body_font = esc_html(get_theme_mod('mobile_app_launch_body_text'));

	if( $mobile_app_launch_headings_font ) {
		wp_enqueue_style( 'mobile-app-launch-headings-fonts', '//fonts.googleapis.com/css?family='. $mobile_app_launch_headings_font );
	} else {
		// Enqueue Google Fonts
		wp_enqueue_style('mobile-app-launch-google-fonts', mobile_app_launch_google_font_url(), array(), null);
	}
	if( $mobile_app_launch_body_font ) {
		wp_enqueue_style( 'mobile-app-launch-body-fonts', '//fonts.googleapis.com/css?family='. $mobile_app_launch_body_font );
	} else {
		// Enqueue main stylesheet with dynamic version
		wp_enqueue_style('mobile-app-launch-main-style', get_stylesheet_uri(), array(), '1.0.0');
        // Add more enqueuing here if needed
	}
}
add_action( 'wp_enqueue_scripts', 'mobile_app_launch_scripts_styles' );


/**
 * Enqueue theme copyright alignment style.
 */
function mobile_app_launch_copyright_alignment_option() {
    // Get the alignment setting from the theme customizer.
    $mobile_app_launch_copyright_alignment = get_theme_mod('mobile_app_launch_copyright_alignment', 'center');

    // Start building the CSS string for the alignment.
    $mobile_app_launch_copyright_alignment_css = '
        .copyright-text, .footer-copyright, .footer-copyright a, p.copyright-text {
            text-align: ' . esc_attr($mobile_app_launch_copyright_alignment) . ';
        }
    ';

    // Add the inline style to the theme's main stylesheet.
    wp_add_inline_style('mobile-app-launch-style', $mobile_app_launch_copyright_alignment_css);
}

add_action('wp_enqueue_scripts', 'mobile_app_launch_copyright_alignment_option');

function Mobile_App_Launch_Customize_css() {
    $mobile_app_launch_dynamic_color_one = get_theme_mod( 'mobile_app_launch_dynamic_color_one', '#0047FF' );
    $mobile_app_launch_dynamic_color_two = get_theme_mod( 'mobile_app_launch_dynamic_color_two', '#FF725D' );

    $mobile_app_launch_custom_css = "
        :root {
            --color-primary1: {$mobile_app_launch_dynamic_color_one};
            --color-primary2: {$mobile_app_launch_dynamic_color_two};
        }
    ";

    // Add the custom CSS inline to the site
    wp_add_inline_style( 'mobile-app-launch-style', $mobile_app_launch_custom_css );
}
add_action( 'wp_enqueue_scripts', 'Mobile_App_Launch_Customize_css' );

// Helper function to get page ID by slug
function get_page_id_by_slug($mobile_app_launch_slug) {
    $mobile_app_launch_page = get_page_by_path($mobile_app_launch_slug); // Get the page by slug
    return $mobile_app_launch_page ? $mobile_app_launch_page->ID : 0;   // Return the page ID or 0 if not found
}

// Sanitize the input
function mobile_app_launch_sanitize_sidebar_position( $mobile_app_launch_input ) {
    $mobile_app_launch_valid = array( 'right', 'left' );

    if ( in_array( $mobile_app_launch_input, $mobile_app_launch_valid ) ) {
        return $mobile_app_launch_input;
    } else {
        return 'right';
    }
}

function mobile_app_launch_sanitize_number_absint( $number, $setting ) {
    // Ensure $number is an absolute integer (whole number, zero or greater).
    $number = absint( $number );

    // If the input is an absolute integer, return it; otherwise, return the default
    return ( $number ? $number : $setting->default );
}

// Show Admin Notice
function mobile_app_launch_promo_notice() {
    if (get_option('mobile_app_launch_notice_dismissed')) {
        return;
    }

    if (isset($_GET['page']) && in_array($_GET['page'], ['mobileapplaunch-wizard'])) {
        return;
    }
    

    $mobile_app_launch_theme = wp_get_theme();
    $mobile_app_launch_theme_title = $mobile_app_launch_theme->get( 'Name' );
    $mobile_app_launch_theme_version = $mobile_app_launch_theme->get( 'Version' );

    ?>
    <div class="notice mobile-app-launch-notice is-dismissible">
        <div>
            <h3>
                <span><?php echo esc_html( '(Version: ' . $mobile_app_launch_theme_version . ')' ); ?></span><br>
                <?php esc_html_e( 'Thank you for choosing,', 'mobile-app-launch'); ?>
                <?php echo esc_html( $mobile_app_launch_theme_title ); ?> <?php esc_html_e( '!!!', 'mobile-app-launch'); ?>
            </h3>
            <p><?php esc_html_e( 'Welcome! You can now easily start building your website using our beautiful and user-friendly themes. No need to worry about setup — with our one-click demo importer, your site can look just like the demo in minutes. All the tools and information you need to get started are right here!', 'mobile-app-launch'); ?></p>
            <a class="button button-primary mobile-app-launch-buy-now" href="<?php echo esc_url( MOBILE_APP_LAUNCH_DEMO_IMPORT_URL ); ?>" target="_blank">
                <?php esc_html_e( 'One Click Demo Import', 'mobile-app-launch') ?>
            </a>
            <a class="button button-primary mobile-app-launch-bundle-button" target="_blank" href="<?php echo esc_url( MOBILE_APP_LAUNCH_THEME_BUNDLE_URL ); ?>">
                <?php echo esc_html__( 'Get All 60+ Themes @ $79', 'mobile-app-launch' ); ?>
            </a>
        </div>
        <div class="mobile-app-launch-image-wrap">
            <img src="<?php echo esc_url(get_stylesheet_directory_uri() . '/screenshot.png'); ?>">
        </div>
        <canvas id="mobile-app-launch-notice-confetti"></canvas>
    </div>
    <?php
}
add_action('admin_notices', 'mobile_app_launch_promo_notice');

add_action('wp_ajax_mobile_app_launch_dismiss_notice', 'mobile_app_launch_dismiss_notice');
function mobile_app_launch_dismiss_notice() {
    update_option('mobile_app_launch_notice_dismissed', true);
    wp_send_json_success();
}

add_action('after_switch_theme', 'mobile_app_launch_reset_notice_on_activation');
function mobile_app_launch_reset_notice_on_activation() {
    delete_option('mobile_app_launch_notice_dismissed');
}

function mobile_app_launch_enqueue_admin_assets() {
    wp_enqueue_script(
        'mobile-app-launch-confetti',
        get_template_directory_uri() . '/demo-import/assets/js/confetti/confetti.min.js',
        ['jquery'],
        null,
        true
    );

    wp_enqueue_script(
        'mobile-app-launch-notice-confetti-js',
        get_template_directory_uri() . '/demo-import/assets/js/plugin-update-notice.js',
        ['mobile-app-launch-confetti'],
        null,
        true
    );

    wp_enqueue_script(
        'mobile-app-launch-notice-dismiss',
        get_template_directory_uri() . '/demo-import/assets/js/notice-dismiss.js',
        ['jquery'],
        null,
        true
    );
}
add_action('admin_enqueue_scripts', 'mobile_app_launch_enqueue_admin_assets');